"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceNotReachableError = exports.DeviceNotImplementedError = exports.MethodNotImplementedError = exports.InvalidTypeError = void 0;
class InvalidTypeError extends Error {
    constructor(message) {
        super(message);
        // see: typescriptlang.org/docs/handbook/release-notes/typescript-2-2.html
        Object.setPrototypeOf(this, new.target.prototype); // restore prototype chain
        this.name = InvalidTypeError.name; // stack traces display correctly now
    }
}
exports.InvalidTypeError = InvalidTypeError;
class MethodNotImplementedError extends Error {
    constructor(message) {
        super(message);
        // see: typescriptlang.org/docs/handbook/release-notes/typescript-2-2.html
        Object.setPrototypeOf(this, new.target.prototype); // restore prototype chain
        this.name = MethodNotImplementedError.name; // stack traces display correctly now
    }
}
exports.MethodNotImplementedError = MethodNotImplementedError;
class DeviceNotImplementedError extends Error {
    constructor(message) {
        super(message);
        // see: typescriptlang.org/docs/handbook/release-notes/typescript-2-2.html
        Object.setPrototypeOf(this, new.target.prototype); // restore prototype chain
        this.name = DeviceNotImplementedError.name; // stack traces display correctly now
    }
}
exports.DeviceNotImplementedError = DeviceNotImplementedError;
class DeviceNotReachableError extends Error {
    constructor(message) {
        super(message);
        // see: typescriptlang.org/docs/handbook/release-notes/typescript-2-2.html
        Object.setPrototypeOf(this, new.target.prototype); // restore prototype chain
        this.name = DeviceNotReachableError.name; // stack traces display correctly now
    }
}
exports.DeviceNotReachableError = DeviceNotReachableError;
//# sourceMappingURL=errors.js.map