import { Nullable } from 'homebridge';
import type { PlatformAccessory, CharacteristicGetCallback } from 'homebridge';
import { DingzDaHomebridgePlatform } from './platform';
import { DingzDaBaseAccessory } from './lib/dingzDaBaseAccessory';
/**
 * Platform Accessory
 * An instance of this class is created for each accessory your platform registers
 * Each accessory may expose multiple services of different service types.
 */
export declare class MyStromButtonAccessory extends DingzDaBaseAccessory {
    protected readonly _platform: DingzDaHomebridgePlatform;
    protected readonly _accessory: PlatformAccessory;
    private buttonState;
    private switchButtonState;
    protected batteryLevel: Nullable<number>;
    protected chargingState: boolean;
    constructor(_platform: DingzDaHomebridgePlatform, _accessory: PlatformAccessory);
    protected buttonServiceSetup(): void;
    private getButtonState;
    protected getSwitchButtonState(callback: CharacteristicGetCallback): void;
    protected getBatteryLevel(callback: CharacteristicGetCallback): void;
    protected getStatusBatteryLow(callback: CharacteristicGetCallback): void;
    protected getChargingState(callback: CharacteristicGetCallback): void;
    protected getDeviceStateUpdate(): Promise<void>;
}
//# sourceMappingURL=myStromButtonAccessory.d.ts.map