import type { PlatformAccessory } from 'homebridge';
import { DingzDaHomebridgePlatform } from './platform';
import { AccessoryActionUrl } from './lib/commonTypes';
import { DingzDaBaseAccessory } from './lib/dingzDaBaseAccessory';
/**
 * Platform Accessory
 * An instance of this class is created for each accessory your platform registers
 * Each accessory may expose multiple services of different service types.
 */
export declare class MyStromPIRAccessory extends DingzDaBaseAccessory {
    private readonly _platform;
    private readonly _accessory;
    private readonly mutex;
    private motionService;
    private temperatureService;
    private lightService;
    private mystromDeviceInfo;
    private pirState;
    constructor(_platform: DingzDaHomebridgePlatform, _accessory: PlatformAccessory);
    private setCallbackUrl;
    /**
     * Returns the callback URL for the device
     */
    getButtonCallbackUrl(): Promise<AccessoryActionUrl>;
    protected getDeviceStateUpdate(): Promise<void>;
    /**
     * Handle Handle the "GET" requests from HomeKit
     * to get the current value of the "Ambient Light Level" characteristic
     */
    private getLightLevel;
    /**
     * Handle Handle the "GET" requests from HomeKit
     * to get the current value of the "Temperature" characteristic
     */
    private getTemperature;
    /**
     * Handle Handle the "GET" requests from HomeKit
     * to get the current value of the "Motion Detected" characteristic
     */
    private getMotionDetected;
    private getDeviceReport;
    identify(): void;
}
//# sourceMappingURL=myStromPIRAccessory.d.ts.map